/* display.h */
/* utility functions of reXgrep */
/* Copyright (C) 1999 Rohit Singh <rohit_singh@hotmail.com>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

void close_application( GtkWidget *widget, GdkEvent  *event, gpointer data);
void show_output(GtkWidget *window, char * commandToGive);
void save_results(GtkWidget *window);

void close_application( GtkWidget *widget, GdkEvent  *event, gpointer data)
    {
      gtk_widget_destroy(widget);
    }

void stop_grep( GtkWidget *widget)
    {
      stop_flag = 1;
    }

void show_output(GtkWidget *win, gchar * commandToGive)
    {
      GdkFont   *fixed_font;
      GtkWidget *window;
      GtkWidget *box1;
      GtkWidget *box2;
      GtkWidget *save_button;
      GtkWidget *close_button;
      GtkWidget *stop_button;
      GtkWidget *separator;
      GtkWidget *table;
      GtkWidget *vscrollbar;

      FILE *infile;

      window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
      gtk_widget_set_usize (window, 600, 300);
      gtk_window_set_policy (GTK_WINDOW(window), TRUE, TRUE, FALSE);  
      gtk_signal_connect (GTK_OBJECT (window), "destroy",
                          GTK_SIGNAL_FUNC(close_application),
                          NULL);
      gtk_window_set_title (GTK_WINDOW (window), "Results of reXgrep");
      gtk_container_set_border_width (GTK_CONTAINER (window), 0);
      
      box1 = gtk_vbox_new (FALSE, 0);
      gtk_container_add (GTK_CONTAINER (window), box1);
      gtk_widget_show (box1);
     
      box2 = gtk_vbox_new (FALSE, 10);
      gtk_container_set_border_width (GTK_CONTAINER (box2), 10);
      gtk_box_pack_start (GTK_BOX (box1), box2, TRUE, TRUE, 0);
      gtk_widget_show (box2);
      
      table = gtk_table_new (2, 1, FALSE);
      gtk_table_set_row_spacings (GTK_TABLE (table),  2);
      gtk_table_set_col_spacings (GTK_TABLE (table),  2);
      gtk_box_pack_start (GTK_BOX (box2), table, TRUE, TRUE, 0);
      gtk_widget_show (table);
      
      text = gtk_text_new (NULL, NULL);
      gtk_text_set_editable (GTK_TEXT (text), TRUE);
      gtk_table_attach (GTK_TABLE (table), text, 0, 1, 0, 1,
                        GTK_EXPAND | GTK_SHRINK | GTK_FILL,
                        GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
      gtk_widget_show (text);

      vscrollbar = gtk_vscrollbar_new (GTK_TEXT (text)->vadj);
      gtk_table_attach (GTK_TABLE (table), vscrollbar, 1, 2, 0, 1,
                        GTK_FILL, GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
      gtk_widget_show (vscrollbar);

      gtk_widget_realize (text);

      fixed_font = gdk_font_load("-misc-fixed-medium-r-*-*-*-140-*-*-*-*-*-*");
      
      separator = gtk_hseparator_new ();
      gtk_box_pack_start (GTK_BOX (box1), separator, FALSE, TRUE, 0);
      gtk_widget_show (separator);

      box2 = gtk_hbox_new (FALSE, 10);
      gtk_container_set_border_width (GTK_CONTAINER (box2), 10);
      gtk_box_pack_start (GTK_BOX (box1), box2, FALSE, TRUE, 0);
      gtk_widget_show (box2);

      save_button = gtk_button_new_with_label ("save");
      gtk_signal_connect(GTK_OBJECT(save_button), "clicked",
                           GTK_SIGNAL_FUNC(set_mode_to_SAVE), NULL);
      gtk_signal_connect(GTK_OBJECT (save_button), "clicked",
                          GTK_SIGNAL_FUNC(get_filename),
                          NULL);

      gtk_box_pack_start (GTK_BOX (box2), save_button, TRUE, TRUE, 0);
      GTK_WIDGET_SET_FLAGS (save_button, GTK_CAN_DEFAULT);

      close_button = gtk_button_new_with_label ("close");
      gtk_signal_connect_object (GTK_OBJECT (close_button), "clicked",
                          GTK_SIGNAL_FUNC(gtk_widget_destroy),
                          GTK_OBJECT(window));
      gtk_box_pack_start (GTK_BOX (box2), close_button, TRUE, TRUE, 0);
      GTK_WIDGET_SET_FLAGS (close_button, GTK_CAN_DEFAULT);
      gtk_widget_grab_default (close_button);

      stop_button = gtk_button_new_with_label ("Stop !");
      gtk_signal_connect_object (GTK_OBJECT (stop_button), "clicked",
                          GTK_SIGNAL_FUNC(stop_grep),
                          GTK_OBJECT(window));
      gtk_box_pack_start (GTK_BOX (box2), stop_button, TRUE, TRUE, 0);
      GTK_WIDGET_SET_FLAGS (stop_button, GTK_CAN_DEFAULT);
      gtk_widget_grab_default (stop_button);
      gtk_widget_show (stop_button);

      gtk_widget_show(window);

      infile = popen(commandToGive, "r");

      if (infile) 
      {
        char buffer[BUF_SIZE];
        int nchars;
        
        while (!(stop_flag))
          {
            nchars = fread(buffer, 1, BUF_SIZE, infile);

            while(gtk_events_pending())
                  gtk_main_iteration(); /* To Prevent window from ~Freezing~ */
            gtk_text_insert (GTK_TEXT (text), fixed_font, NULL,
                             NULL, buffer, nchars);
	
	    if (nchars == 0)            /* No Matches found for grep         */	
            gtk_text_insert (GTK_TEXT (text), fixed_font, NULL,
                             NULL, "Match not found!",16 );
   
            if (nchars < BUF_SIZE)
              break;
          }
        
        pclose (infile);
      }
      gtk_widget_hide(GTK_WIDGET(stop_button));

      gtk_widget_show(close_button);
      gtk_widget_show(save_button);

      gtk_widget_show (window);
    }
