/* fileutils.h */
/* utility functions of reXgrep */
/* Copyright (C) 1999 Rohit Singh <rohit_singh@hotmail.com>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

void file_ok_sel (GtkWidget *w, GtkFileSelection *fs);
void get_filename( GtkWidget *widget);

void file_ok_sel (GtkWidget *w, GtkFileSelection *fs)
{

	char *bigbuffer;
	int output_fd;
        int buf_start = 0;
        int size_of_buf = BUF_SIZE;

        bigbuffer = (char *) malloc(BUF_SIZE);
 	strcpy(location,gtk_file_selection_get_filename(GTK_FILE_SELECTION(fs)));
         

	if (mode==READ)
	{
        	gtk_entry_set_text(GTK_ENTRY(entry),location);
	}
	else
	if (mode==SAVE) /* Changed Substantially at the start of the millennium! */
	{
		output_fd = open(location, O_CREAT|O_WRONLY);
		if (output_fd == -1)
		{
			printf("Error in opening Results File\n");
			return;
		}
		else 
		{
		  memset(bigbuffer,0,sizeof(bigbuffer));
                  do {
 
	             strncpy(bigbuffer, 
                       gtk_editable_get_chars(GTK_EDITABLE(text),buf_start, -1),
                       BUF_SIZE);
                     size_of_buf = strlen(bigbuffer);
                     if (write(output_fd, bigbuffer, size_of_buf) == -1)
                     {
	                printf("Error writing to output file\n");
                        close(output_fd);
	                return;
                     }
	             buf_start   += size_of_buf;
                  } while (!(size_of_buf < BUF_SIZE));
		  close(output_fd);
                }
	}
}
        
void get_filename( GtkWidget *widget)
        {
        GtkWidget * filesel;
	gchar    *currdir;

      	if(mode==SAVE){
        	filesel = gtk_file_selection_new ("Save Results");
        }else{
        	filesel = gtk_file_selection_new ("File selection");
	}
        gtk_signal_connect (GTK_OBJECT(GTK_FILE_SELECTION(filesel)->ok_button),
                "clicked", (GtkSignalFunc) file_ok_sel, filesel);
 	gtk_signal_connect_object (GTK_OBJECT(GTK_FILE_SELECTION(filesel)->ok_button),
                                "clicked",GTK_SIGNAL_FUNC(gtk_widget_destroy),
				 GTK_OBJECT(filesel));
         
        gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION
                (filesel)->cancel_button),"clicked", GTK_SIGNAL_FUNC
                (gtk_widget_destroy), GTK_OBJECT (filesel));
	if (mode == READ)
	{       
	        currdir = gtk_entry_get_text(GTK_ENTRY(entry)); 
	        gtk_file_selection_set_filename (GTK_FILE_SELECTION(filesel),
                                         currdir);
	}
	else if (mode == SAVE)
	{
	        gtk_file_selection_set_filename (GTK_FILE_SELECTION(filesel),
                                         "~/reXgrepResult");
	}
	
        gtk_widget_show(filesel);

}










