/* rexgrep.c 						*/
/* main rexgrep file 					*/
/* Copyright (C) 1999 Rohit Singh <rohit_singh@hotmail.com>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "config.h"

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <sys/types.h>
#include <fcntl.h>
#include <sys/stat.h>

#include <unistd.h>
#include <gtk/gtk.h>
#include <glib.h>

#include "globals.h"
#include "globalparser.h"
#include "utils.h"
#include "fileutils.h"
#include "display.h"


    	void radio_button_selected (GtkWidget *widget, gpointer data)
    	{
        if (GTK_TOGGLE_BUTTON (widget)->active) 
        	{
		greptype = GPOINTER_TO_INT(data);
        	} 
    	}

	void recurse(GtkWidget *widget, gpointer data)
	{
	if (GTK_TOGGLE_BUTTON (widget)->active)
        	{
		recursive_flag=1;
		}
	 else 	{
		recursive_flag=0;
		}
	}

	void ignore_case(GtkWidget *widget)
	{
	if (GTK_TOGGLE_BUTTON (widget)->active)
        	{
		ignore_case_flag=1;
		}
	else
		{
		ignore_case_flag=0;
		}	
	}

	void show_line_number(GtkWidget *widget)
	{
	if (GTK_TOGGLE_BUTTON (widget)->active)
        	{
		line_number_flag=1;
		}
	else
		{
		line_number_flag=0;
		}	
	}

	void go_help(GtkWidget *window)
	{
	char *cmd;

	 cmd = (char *)alloca((strlen(CONFIG_XTERM) +
		strlen(CONFIG_MAN) + 32) * sizeof(char));

	sprintf(cmd, "exec %s -e %s rexgrep &", CONFIG_XTERM, CONFIG_MAN);

	system(cmd);
	}

    	void enter_callback(GtkWidget *widget, GtkWidget *entry)
    	{
      	gchar *entry_text;
      	entry_text = gtk_entry_get_text(GTK_ENTRY(entry));
    	}

    	void key_enter_callback(GtkWidget *widget, GtkWidget *entry)
    	{
      	gchar *entry_text;
      	entry_text = gtk_entry_get_text(GTK_ENTRY(keyentry));
    	}


    	void go_grep(GtkWidget *window)
    	{
	gchar *location;
	gchar *keywords;
	gchar command[MAX_CMD_LEN], buffer[MAX_CMD_LEN];
	int loclen, keylen, i;
	int contextA, contextB;
	int no_of_keywords;

        GdkCursor *watch_cursor;
        GdkCursor *normal_cursor;
    
        watch_cursor = gdk_cursor_new(GDK_WATCH);
        gdk_window_set_cursor(mainwindow->window, watch_cursor);
    
	contextA=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spinnerA));	
        contextB=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spinnerB));

        location = gtk_entry_get_text(GTK_ENTRY(entry));
        keywords = gtk_entry_get_text(GTK_ENTRY(keyentry));

	loclen = strlen(location);

	if ((!recursive_flag)&&(location[loclen-1]=='/'))
	{		
		location[loclen]='*';
		location[loclen+1]='\0';
		loclen++;
	}


	keylen = strlen(keywords);

	switch(greptype){

		case PHRASE:
                        memset(command,0,MAX_CMD_LEN);
		        sprintf(command, "grep '%s' %s %s %s %s %s 2>&1",
			 keywords, linenumber_str(line_number_flag),
			 context_str(contextA, contextB),
			 caseignore_str(ignore_case_flag),
			 recurse_str(recursive_flag), location); 
		break;

		case ALL   :
			memset(command,0,MAX_CMD_LEN);
			no_of_keywords = parse_keywords(keywords);
			sprintf(buffer, "grep -e '%s' %s %s %s %s %s ",
			 single_keyword[0],
			 linenumber_str(line_number_flag),
			 context_str(contextA,contextB),
			 caseignore_str(ignore_case_flag),
			 recurse_str(recursive_flag), location); 
			strcat(command, buffer);
	
			for (i=1; i<no_of_keywords; i++)			
			{
				sprintf(buffer," | grep -e '%s' %s",
			single_keyword[i], context_str(contextA,contextB));
				strcat(command, buffer);
			}
			break;

		case SOME  :
			memset(command,0,MAX_CMD_LEN);
			no_of_keywords = parse_keywords(keywords);

		sprintf(buffer, "grep -e '%s' %s %s %s %s %s 2>&1",
				 single_keyword[0],
				 linenumber_str(line_number_flag),
				 context_str(contextA,contextB),
				 caseignore_str(ignore_case_flag),
				 recurse_str(recursive_flag), location);
                                 if (no_of_keywords > 1)
                                      strcat(buffer," ;"); 
				strcat(command,buffer);

			for (i=1; i< no_of_keywords; i++)			
			{
		sprintf(buffer, "grep -e '%s' %s %s %s %s %s",
				 single_keyword[i],
				 linenumber_str(line_number_flag),
				 context_str(contextA,contextB),
				 caseignore_str(ignore_case_flag),
				 recurse_str(recursive_flag), location);
                                 if ((i+1) != no_of_keywords)
                                      strcat(buffer," ;"); 
				strcat(command,buffer);
			}
			break;

		case NONE  :
			memset(command,0,MAX_CMD_LEN);
			no_of_keywords = parse_keywords(keywords);
			sprintf(buffer, "grep -v -e '%s' %s %s %s %s %s 2>&1",
			 single_keyword[0], context_str(contextA,contextB),
			 linenumber_str(line_number_flag),
			 caseignore_str(ignore_case_flag),
			 recurse_str(recursive_flag), location); 
			strcat(command, buffer);
	
			for (i=1; i<no_of_keywords; i++)			
			{
				sprintf(buffer," | grep -v -e '%s' %s ",
			single_keyword[i], context_str(contextA,contextB));
				strcat(command, buffer);
			}
			break;


		case REGEX :
			memset(command,0,MAX_CMD_LEN);
			sprintf(command, "grep -e %s %s %s %s %s %s 2>&1",
			 keywords, 
			 linenumber_str(line_number_flag),
			 context_str(contextA, contextB),
			 caseignore_str(ignore_case_flag),
			 recurse_str(recursive_flag), location); 
			break;

		default    : printf("Error! greptype confused\n");
	}
    stop_flag=0; /* Disable Stop Flag for Results Window */
    show_output(window, command);

    gdk_cursor_destroy(watch_cursor);
    normal_cursor = gdk_cursor_new(GDK_TOP_LEFT_ARROW);
    gdk_window_set_cursor(mainwindow->window, normal_cursor);

    }



int main( int   argc, char *argv[] )
    {
        GtkWidget *window = NULL;
        GtkWidget *box1;
        GtkWidget *box2;
        GtkWidget *boxtop;
        GtkWidget *hbox_ggrep;
        GtkWidget *vbox_find;
        GtkWidget *vbox_checkboxes;
        GtkWidget *options_frame, *find_frame;
        GtkWidget *check_box;
        GtkWidget *button;
	GtkWidget *hbox, *vbox2;
        GtkWidget *label;
	GtkAdjustment	*adj;
        GSList  *group;
	char	currdir[MAX_DIR_LEN];
	char	*home, *getenv();
	char	*rexfile="/.reXgrep";

	if ((home = getenv("HOME")) == (char *) 0)
	{	
		strcpy(home,"/tmp/.reXgrep");
		sprintf(OUTPUT_FILE,"%s",home);
	}
	else
	{
		sprintf(OUTPUT_FILE,"%s%s",home,rexfile);
	}


        gtk_init(&argc,&argv);    
        
  	if(get_bool_option(argc, argv, "-version")) {
    	printf("%s\n", version);
    	gtk_exit(0);
  	}
  	if(get_bool_option(argc, argv, "-help")) {
    	printf("%s - a graphical grepping program using the GTK+ toolkit\n",
           version);
    	printf("Type \"man rexgrep\" to view the manual page\n");
    	printf("options:\n");
    	printf("\t-version\tPrint the version and exit\n");
    	printf("\t-help\t\tPrint this message and exit\n");
    	gtk_exit(0);
  	}

 	mainwindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
      
        gtk_signal_connect (GTK_OBJECT (mainwindow), "delete_event",
                            GTK_SIGNAL_FUNC(gtk_main_quit),
                            NULL);

        gtk_window_set_title (GTK_WINDOW (mainwindow), "reXgrep");
        gtk_container_set_border_width (GTK_CONTAINER (mainwindow), 10);

        boxtop = gtk_vbox_new (FALSE, 5);
        gtk_container_add (GTK_CONTAINER (mainwindow), boxtop);
        gtk_widget_show (boxtop);

        hbox_ggrep = gtk_hbox_new (FALSE, 0);
        gtk_container_add (GTK_CONTAINER (boxtop), hbox_ggrep);
        gtk_widget_show (hbox_ggrep);

        box1 = gtk_vbox_new (FALSE, 0);
        gtk_container_add (GTK_CONTAINER (hbox_ggrep), box1);
        gtk_widget_show (box1);


	find_frame = gtk_frame_new("Find");
	gtk_frame_set_shadow_type( GTK_FRAME(find_frame),
				GTK_SHADOW_OUT);
	gtk_box_pack_start(GTK_BOX(hbox_ggrep), find_frame, FALSE,
								FALSE, 0);
        gtk_widget_show(find_frame);

        vbox_find = gtk_vbox_new (FALSE, 0);
        gtk_container_add (GTK_CONTAINER (find_frame),vbox_find);
        gtk_widget_show (vbox_find);


	box2 = gtk_hbox_new(FALSE,0);
	gtk_container_add(GTK_CONTAINER(vbox_find), box2);
        gtk_container_set_border_width (GTK_CONTAINER (box2), 0);
	gtk_widget_show (box2);

	label = gtk_label_new("Look for:");
	gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 3);
	gtk_widget_show(label);

        keyentry = gtk_entry_new_with_max_length (MAX_DIR_LEN);  
        gtk_signal_connect(GTK_OBJECT(keyentry), "activate",
                           GTK_SIGNAL_FUNC(key_enter_callback),
                           keyentry);
	gtk_entry_set_text (GTK_ENTRY (keyentry), "Put keywords here...");
	gtk_entry_select_region (GTK_ENTRY (keyentry),
                                 0, GTK_ENTRY(keyentry)->text_length);
        gtk_box_pack_start(GTK_BOX (box2), keyentry, TRUE, TRUE, 0);
        gtk_widget_show (keyentry);

        box2 = gtk_hbox_new (FALSE, 10); 
        gtk_container_set_border_width (GTK_CONTAINER (box2), 3);
        gtk_box_pack_start (GTK_BOX (vbox_find), box2, TRUE, TRUE, 0);
        gtk_widget_show (box2);

        button = gtk_radio_button_new_with_label (NULL, "Phrase");
        gtk_box_pack_start (GTK_BOX (box2), button, TRUE, TRUE, 0);
        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
        gtk_signal_connect(GTK_OBJECT(button), "toggled",
                           GTK_SIGNAL_FUNC(radio_button_selected),
                           GINT_TO_POINTER(PHRASE));
        gtk_widget_show (button);

        group = gtk_radio_button_group (GTK_RADIO_BUTTON (button));
        button = gtk_radio_button_new_with_label(group, "All");
        gtk_box_pack_start (GTK_BOX (box2), button, TRUE, TRUE, 0);
        gtk_signal_connect(GTK_OBJECT(button), "toggled",
                           GTK_SIGNAL_FUNC(radio_button_selected),
                           GINT_TO_POINTER(ALL));
        gtk_widget_show (button);

        button = gtk_radio_button_new_with_label(
                     gtk_radio_button_group (GTK_RADIO_BUTTON (button)),
                     "Some");
        gtk_box_pack_start (GTK_BOX (box2), button, TRUE, TRUE, 0);
        gtk_signal_connect(GTK_OBJECT(button), "toggled",
                           GTK_SIGNAL_FUNC(radio_button_selected),
                           GINT_TO_POINTER(SOME));
        gtk_widget_show (button);

        button = gtk_radio_button_new_with_label(
                     gtk_radio_button_group (GTK_RADIO_BUTTON (button)),
                     "None");
        gtk_box_pack_start (GTK_BOX (box2), button, TRUE, TRUE, 0);
        gtk_signal_connect(GTK_OBJECT(button), "toggled",
                           GTK_SIGNAL_FUNC(radio_button_selected),
                           GINT_TO_POINTER(NONE));
        gtk_widget_show (button);

        button = gtk_radio_button_new_with_label(
                     gtk_radio_button_group (GTK_RADIO_BUTTON (button)),
                     "Regular Expr.");
        gtk_box_pack_start (GTK_BOX (box2), button, TRUE, TRUE, 0);
        gtk_signal_connect(GTK_OBJECT(button), "toggled",
                           GTK_SIGNAL_FUNC(radio_button_selected),
                           GINT_TO_POINTER(REGEX));
        gtk_widget_show (button);

        box2 = gtk_hbox_new (FALSE, 0);
        gtk_container_set_border_width (GTK_CONTAINER (box2), 3);
        gtk_box_pack_start (GTK_BOX (vbox_find), box2, TRUE, TRUE, 0);
        gtk_widget_show (box2);

	label = gtk_label_new("Look In:");
	gtk_box_pack_start(GTK_BOX(box2), label, FALSE, FALSE, 0);
	gtk_widget_show(label);

        entry = gtk_entry_new_with_max_length (256);  
        gtk_signal_connect(GTK_OBJECT(entry), "activate",
                           GTK_SIGNAL_FUNC(enter_callback),
                           entry);

	getcwd(currdir, sizeof(currdir));
	strcat(currdir,"/");
	gtk_entry_set_text (GTK_ENTRY (entry), currdir);
        gtk_box_pack_start (GTK_BOX (box2), entry, TRUE, TRUE, 0);
        gtk_widget_show (entry);

	button = gtk_button_new_with_label("Browse...");
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
			   GTK_SIGNAL_FUNC(set_mode_to_READ), NULL);
	gtk_signal_connect(GTK_OBJECT(button), "clicked",
			   GTK_SIGNAL_FUNC(get_filename), NULL);
	gtk_box_pack_start (GTK_BOX(box2), button, FALSE, FALSE, 0);
	gtk_widget_show(button);


	options_frame = gtk_frame_new("Options");
        gtk_frame_set_shadow_type( GTK_FRAME(options_frame),
				GTK_SHADOW_OUT);
	gtk_box_pack_start(GTK_BOX(hbox_ggrep), options_frame, FALSE,
								FALSE, 5);
        gtk_widget_show(options_frame);

        vbox_checkboxes = gtk_vbox_new (FALSE, 0);
        gtk_container_add (GTK_CONTAINER (options_frame),vbox_checkboxes);
        gtk_widget_show (vbox_checkboxes);

	check_box = gtk_check_button_new_with_label("Ignore case");
	gtk_box_pack_start(GTK_BOX(vbox_checkboxes), check_box, FALSE,
							FALSE,0);
        gtk_signal_connect(GTK_OBJECT(check_box), "toggled",
                           GTK_SIGNAL_FUNC(ignore_case),
                           NULL);
        gtk_widget_show(check_box);

	check_box = gtk_check_button_new_with_label("Show line numbers");
	gtk_box_pack_start(GTK_BOX(vbox_checkboxes), check_box, FALSE,
							FALSE,0);
        gtk_signal_connect(GTK_OBJECT(check_box), "toggled",
                           GTK_SIGNAL_FUNC(show_line_number),
                           NULL);
        gtk_widget_show(check_box);

	check_box = gtk_check_button_new_with_label("Look in subdirectories");
	gtk_box_pack_start(GTK_BOX(vbox_checkboxes), check_box, FALSE,
							FALSE,0);
        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (check_box),TRUE);
	gtk_signal_connect(GTK_OBJECT(check_box), "toggled",
                           GTK_SIGNAL_FUNC(recurse),
                           NULL);
        gtk_widget_show(check_box);

  /* Before and After spinners */
  
  	hbox = gtk_hbox_new (FALSE, 0);
  	gtk_box_pack_start (GTK_BOX (vbox_checkboxes), hbox, TRUE, TRUE, 5);
	gtk_widget_show(hbox);
  
  	vbox2 = gtk_vbox_new (FALSE, 0);
  	gtk_box_pack_start (GTK_BOX (hbox), vbox2, TRUE, TRUE, 5);
  	gtk_widget_show(vbox2);

  	label = gtk_label_new ("Lines Before:");
  	gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);
  	gtk_box_pack_start (GTK_BOX (vbox2), label, FALSE, TRUE, 0);
  	gtk_widget_show(label);

  	adj = (GtkAdjustment *) gtk_adjustment_new (0, 0, MAX_CONTEXT_LINES,1,5,0); 
					      
  	spinnerB = gtk_spin_button_new (adj, 0, 0);
  /*	gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spinnerB), TRUE);
  */	gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spinnerB),
				   GTK_SHADOW_OUT);
	gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinnerB), TRUE);
  	gtk_box_pack_start (GTK_BOX (vbox2), spinnerB, FALSE, TRUE, 0);
	gtk_widget_show(spinnerB);  

  	vbox2 = gtk_vbox_new (FALSE, 0);
  	gtk_box_pack_start (GTK_BOX (hbox), vbox2, TRUE, TRUE, 5);
  	gtk_widget_show(vbox2);

  	label = gtk_label_new ("Lines After:");
  	gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);
  	gtk_box_pack_start (GTK_BOX (vbox2), label, FALSE, TRUE, 0);
  	gtk_widget_show(label);

  	adj = (GtkAdjustment *) gtk_adjustment_new (0, 0, MAX_CONTEXT_LINES,1,5,0);
   	spinnerA = gtk_spin_button_new (adj, 0, 0);
  /*	gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spinnerA), TRUE);
  */	gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spinnerA),
				   GTK_SHADOW_OUT);
	gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinnerA), TRUE);
  	gtk_box_pack_start (GTK_BOX (vbox2), spinnerA, FALSE, TRUE, 0);
  	gtk_widget_show(spinnerA);  


        box2 = gtk_hbox_new (TRUE, 5);
        gtk_container_set_border_width (GTK_CONTAINER (box2), 3);
        gtk_box_pack_start (GTK_BOX (boxtop), box2, FALSE, TRUE, 0);
        gtk_widget_show (box2);

        button = gtk_button_new_with_label ("Quit");
        gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
                                   GTK_SIGNAL_FUNC(gtk_main_quit),
                                   NULL);
        GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
        gtk_box_pack_start (GTK_BOX (box2), button, TRUE, TRUE, 0);
        gtk_widget_show (button);

        button = gtk_button_new_with_label ("Help");
        gtk_signal_connect(GTK_OBJECT(button), "clicked",
                           GTK_SIGNAL_FUNC(go_help),
                           window);
        gtk_box_pack_start (GTK_BOX (box2), button, TRUE, TRUE, 0);
        GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
        gtk_widget_grab_default (button);
        gtk_widget_show (button);

        button = gtk_button_new_with_label ("Locate");
        gtk_signal_connect(GTK_OBJECT(button), "clicked",
                           GTK_SIGNAL_FUNC(go_grep),
                           window);
        gtk_box_pack_start (GTK_BOX (box2), button, TRUE, TRUE, 0);
        GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
        gtk_widget_grab_default (button);
        gtk_widget_show (button);

        gtk_widget_show (mainwindow);
        gtk_main();

        return(0);
    }
