/* utils.h */
/* utility functions of reXgrep */
/* Copyright (C) 1999 Rohit Singh <rohit_singh@hotmail.com>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

char * recurse_str(int rec);
char * caseignore_str(int rec);
char * context_str(int a, int b);
int get_bool_option(int argc, char *argv[], char *option);
void set_mode_to_READ();
void set_mode_to_SAVE();


void set_mode_to_READ()
    {
        mode=READ;
    }

void set_mode_to_SAVE()
    {
        mode=SAVE;
    }


char * recurse_str(int rec)
{
	char *  buffer;
	buffer =(char *) malloc(5);
	if (rec)	
		sprintf(buffer,"%s"," -r ");
	else
		sprintf(buffer,"%s", "");

	return(buffer);
}

char * caseignore_str(int flag)
{
	char * buffer;
	buffer =(char *) malloc(5);

	if (flag)	
		sprintf(buffer,"%s"," -i ");
	else
		sprintf(buffer,"%s", "");
	return(buffer);
}

char * linenumber_str(int flag) //added 01121999
{
	char * buffer;
	buffer =(char *) malloc(5);

	if (flag)	
		sprintf(buffer,"%s"," -n ");
	else
		sprintf(buffer,"%s", "");
	return(buffer);
}


char * context_str(int a, int b)
{
	char * buffer;
	buffer =(char *) malloc(15);

	sprintf(buffer," -A %d -B %d ",a,b);
	return(buffer);
}

int get_bool_option(int argc, char *argv[], char *option)
{
  int i = 0, rv = 0;
 
  for(i = 0; i < argc; i++) {
    if(strcmp(argv[i], option) == 0) {
      rv = 1;
      goto DONE;
    }
  }

 DONE:
  return(rv);
}

